#pragma warning( disable : 4101 )
#pragma warning( disable : 4102 )
#pragma warning( disable : 4018 )

#pragma comment (lib,"user32.lib")
#ifndef INCLUDEUCHAR
#ifndef uchar
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define ushort  unsigned short
#endif
#endif

#define _equal_ ==

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

// #define NDEBUG

#undef NDEBUG
#include <assert.h>
#include "config.h"
#include "mpg123.h"
#include "mpglib.h"
#include <windows.h>
#include "gain_analysis.h"

__int64 _ftelli64_arab(FILE *stream);
int _fseeki64_arab(FILE *stream,__int64 offset,int origin);
size_t fread_unbuffered(void *ptr, size_t size, size_t nelem, FILE *stream);
size_t fwrite_unbuffered(const void *ptr, size_t size, size_t nelem, FILE *stream);
/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/

//funcoes

WCHAR* __stdcall utf8towide (const char *pUTF8);
FILE *buffer_fopen (const char *filename, const char *mode);
Float_t GetTitleGain (int*error);
char *getnetstatus (int *value);
double getporf (double maxa, double fatiaa);
double getvalf (double maxa, double porr);
double inittimer2 (int value);
int InitMP3 (PMPSTR mp);
int decodeMP3 (PMPSTR mp, unsigned char *in, int isize, char *out, int osize,
	       int *done);
int detect (char *filename, __int64 *seekpoint);
__int64 id3v2tag (char *filename);
int id3v2tag_check (char *filename);
int rewrite_header (FILE * out, unsigned int written);
int write_prelim_header (FILE * out, int channels, int samplerate);
void ExitMP3 (PMPSTR mp);
void dprintf (char *format, ...);
void mprintf (char *format, ...);


extern int posicionador_de_mpeglib;
extern int flag_de_seek_mpeglib_;

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/

//variaveisg
int fastnormalizationmode = 0;



/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/


static const char *modes[4] =
	{ "Stereo", "Joint-Stereo", "Dual-Channel", "Single-Channel" };
static const char *layers[4] = { "Unknown", "I", "II", "III" };

static const long freqs[9] = { 44100, 48000, 32000,
	22050, 24000, 16000,
	11025, 12000, 8000
};



static const int tabsel_123[2][3][16] = {
	{{0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416,
	  448,},
	 {0, 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320,
	  384,},
	 {0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256,
	  320,}},

	{{0, 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224,
	  256,},
	 {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160,},
	 {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160,}}
};

static char out[8192];
float globalfactor;
int analized;
static MPSTR mp;
static char buf[16384];


int mygain (uchar * buf, uint len, float factor)
{
	float temp;
	int tempo;
	int *fatia2 = &tempo;
	int i;
	signed short *fatia;
	signed short salva;

	fatia = (signed short *) buf;

	for (i = 0; i < len; i = i + 2)
	  {
		  *fatia2 = (int) *fatia;
		  temp = (float) *fatia2;
		  temp = temp * factor;
		  *fatia2 = (int) temp;

		  if (*fatia2 > 32767)
		    {
			    *fatia2 = 32767;
		    }
		  if (*fatia2 < -32768)
		    {
			    *fatia2 = -32768;
		    }

		  *fatia = (signed short) *fatia2;
		  fatia++;
	  }
}


int
analize (char *filename, float *globalff, int *aanalized)
{

	FILE *stream = NULL;
	FILE *stream2 = NULL;
	int already = 0;
	__int64 analizedsize = 0;
	int bytesprocessed = 0;
	int chaveador = MP3_NEED_MORE;
	int executed = 0;
	int len, ret;
	int saiagora = 0;
	int sampleslimit = 0;
	int size;
	int sizewrite = 0;

/*HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH*/

	*aanalized = 0;
	*globalff = 1.0;

	if ((stream = _wfopen (utf8towide(filename), L"rb")) != NULL)
	  {
	  }
	else
	  {
		  return 5;
	  }

	{

		__int64 retme = 0;
		int ret3 = 0;

		ret3 = detect (filename, &retme);

		if (ret3 != 0)
		  {
			  fclose (stream);
			  return 5;
		  }

		if (retme)
		  {
			  int ret;
			  ret = _fseeki64_arab (stream, retme, SEEK_SET);
		  }
	}

	InitMP3 (&mp);

	already = 0;


	if (fastnormalizationmode)
	  {

		  __int64 ret;
		  __int64 salva;
		  __int64 tamarq;

		  ret = _ftelli64_arab (stream);
		  salva = _ftelli64_arab (stream);
		  _fseeki64_arab (stream, 0, SEEK_END);
		  ret = (_ftelli64_arab (stream) - ret);

		  tamarq = _ftelli64_arab (stream);



		  if (ret > 160000)
		    {
			    analizedsize = ((ret) / 2) + salva;
		    }
		  else
		    {
			    analizedsize = 0;
		    }

		  _fseeki64_arab (stream, salva, SEEK_SET);

		  if (analizedsize)
		    {
			    _fseeki64_arab (stream, analizedsize, SEEK_SET);
		    }
	  }


	while (1)
	  {
		retornamp3:

		  if (chaveador != MP3_OK)
		    {
posicionador_de_mpeglib=_ftelli64_arab(stream);
			    len = fread_unbuffered (buf, sizeof (char), 500, stream);

			    if ((len <= 0) || saiagora)
			      {
				      break;
			      }

			    if(1)
			    {
				    chaveador =
					    decodeMP3 (&mp, buf, len, out,
						       8192, &size);
							   if(flag_de_seek_mpeglib_)
{
dprintf("flag de seek 1\n");
flag_de_seek_mpeglib_=0;
_fseeki64_arab(stream,posicionador_de_mpeglib+50,SEEK_SET);
}
			    }

		    }
		  else
		    {
			    if(1)
			    {
				    chaveador =
					    decodeMP3 (&mp, NULL, 0, out,
						       8192, &size);
							   if(flag_de_seek_mpeglib_)
{
dprintf("flag de seek 1\n");
flag_de_seek_mpeglib_=0;
_fseeki64_arab(stream,posicionador_de_mpeglib+50,SEEK_SET);
}
			    }
		    }

		  if (chaveador != MP3_OK)
		    {
			    goto retornamp3;

		    }

		  if (already == 0)
		    {

			    int ret;

			    ret = InitGainAnalysis (freqs
						    [mp.fr.
						     sampling_frequency]);

			    if (ret == INIT_GAIN_ANALYSIS_ERROR)
			      {
				      goto saida;
			      }

			    if (mp.fr.stereo != 1 && mp.fr.stereo != 2)
			      {

				      goto saida;
			      }

			    already = 1;
		    }

		  {


			  if (size > 4)
			    {
				    int ret;

				    int i;
				    int counter = 0;

				    float *pcmleft = NULL;
				    float *pcmright = NULL;

				    float *left = NULL;
				    float *right = NULL;
				    static int agora = 0;

				    signed short *data = (short *) out;


				    executed = 1;

				    if (mp.fr.stereo == 1)
				      {

					      if (analizedsize
						  && (!sampleslimit))
						{
							int samplerate =
								freqs[mp.fr.
								      sampling_frequency];
							int channels =
								mp.fr.stereo;
							int averagebyte;
							averagebyte =
								samplerate *
								channels * 2;
							sampleslimit =
								averagebyte *
								10;
						}


					      left = (float *)
						      malloc (((size / 2) *
							       sizeof (float))
							      + 4);
					      pcmleft = left;

					      for (i = 0; i < size; i = i + 2)
						{
							*pcmleft =
								(float) *data;
							pcmleft++;
							data++;
						}

					      ret = AnalyzeSamples (left,
								    NULL,
								    (size /
								     2), 1);
					      bytesprocessed =
						      bytesprocessed + size;

					      if (sampleslimit)
						{

							if (bytesprocessed >
							    sampleslimit)
							  {
								  saiagora =
									  1;
								  chaveador =
									  MP3_ERR;
							  }
						}
				      }
				    else if (mp.fr.stereo == 2)
				      {
					      if (analizedsize
						  && (!sampleslimit))
						{
							int samplerate =
								freqs[mp.fr.
								      sampling_frequency];
							int channels =
								mp.fr.stereo;
							int averagebyte;

							averagebyte =
								samplerate *
								channels * 2;
							sampleslimit =
								averagebyte *
								10;

						}

					      left = (float *)
						      malloc (((size / 4) *
							       sizeof (float))
							      + 4);
					      pcmleft = left;
					      right = (float *)
						      malloc (((size / 4) *
							       sizeof (float))
							      + 4);
					      pcmright = right;

					      for (i = 0; i < size; i = i + 4)
						{
							*pcmleft =
								(float) *data;
							pcmleft++;
							data++;
							*pcmright =
								(float) *data;
							pcmright++;
							data++;

						}

					      ret = AnalyzeSamples (left,
								    right,
								    (size /
								     4), 2);
					      bytesprocessed =
						      bytesprocessed + size;

					      if (sampleslimit)
						{

							if (bytesprocessed >
							    sampleslimit)
							  {
								  saiagora =
									  1;
								  chaveador =
									  MP3_ERR;
							  }

						}

				      }

				    if (left)
				      {
					      free (left);
				      }

				    if (right)
				      {
					      free (right);
				      }


				    if (ret == GAIN_ANALYSIS_ERROR)
				      {
					      goto saida2;
				      }
			    }
		  }
	  }

      saida:

	if (executed)
	  {

		  float fator;
int error=0;//papa
		  fator = GetTitleGain (&error);
		  fator = (float) pow (10., fator / 20.);//como ?

		  if (fator > 15)
		    {
			    fator = 1.0;
		    }

			if(error)
			{
			
			}
			else
			{
		  *globalff = fator;
		  }
		  *aanalized = 1;
	  }

      saida2:

	ExitMP3 (&mp);
	fclose (stream);

	return 0;

}
